#include "EventTimer.H"

long ET_tot_ticks = 0;
long ET_tot_calls = 0;

struct tms ET_sT;
struct tms ET_eT;
double ET_ticksS = (double)sysconf(_SC_CLK_TCK);

clock_t ET_start;
clock_t ET_end;

void EventTimer::start() {
	ET_start = times(&ET_sT);
}

void EventTimer::stop() {
	stop(0);
}

void EventTimer::stop(int outputFreq) {
	ET_end = times(&ET_eT);
	ET_tot_ticks += (ET_eT.tms_utime - ET_sT.tms_utime);
	ET_tot_calls++;

	if (outputFreq > 0) {
		double totTime = (double)ET_tot_ticks / ET_ticksS;
		double avgTime = (((double)ET_tot_ticks / (double)ET_tot_calls) / ET_ticksS);
		double avgTicks = (double)ET_tot_ticks / (double)ET_tot_calls;
		double current = (((double)ET_eT.tms_utime - (double)ET_sT.tms_utime) / ET_ticksS);
		if (outputFreq == 1) {
			cout << "Calls=" << ET_tot_calls << " previousTime=" << current << " totalTime=" << totTime << " avgTime=" << avgTime << " totalCPUTicks=" << ET_tot_ticks << " avgCPUTicks=" << avgTicks << endl;
		}
		else {
			if (ET_tot_calls % outputFreq == 0) {
				cout << "Calls=" << ET_tot_calls << " previousTime=" << current << " totalTime=" << totTime << " avgTime=" << avgTime << " totalCPUTicks=" << ET_tot_ticks << " avgCPUTicks=" << avgTicks << endl;
			}
		}
	}
}

double EventTimer::getAvgTime() {
	double avgTime = (((double)ET_tot_ticks / (double)ET_tot_calls) / ET_ticksS);
	return avgTime;
}
