#include "BattlePlan.H"

const sint4 BattlePlan::NONE_FOUND = 0;
const sint4 BattlePlan::BUILD_BARRACKS = 1;
const sint4 BattlePlan::TRAIN_WORKER = 2;
const sint4 BattlePlan::TRAIN_MARINE = 3;
const sint4 BattlePlan::EXPLORE = 4;
const sint4 BattlePlan::BUILD_FACTORY = 5;
const sint4 BattlePlan::BUILD_TANK = 6;

BattlePlan::BattlePlan() {
	noObjs = 0;
}

void BattlePlan::addObjective(int minResources, int no, int cmd, sint4 executer) {
	Objective o;
	o.minResources = minResources;
	o.no = no;
	o.done = 0;
	o.cmd = cmd;
	o.executer = executer;
	objectives.push_back(o);
	noObjs++;
}

void BattlePlan::insertObjectiveFirst(int minResources, int no, int cmd, sint4 executer) {
	Objective o;
	o.minResources = minResources;
	o.no = no;
	o.done = 0;
	o.cmd = cmd;
	o.executer = executer;

	vector<Objective>::iterator it = objectives.begin();
	objectives.insert(it, o);
	
	noObjs++;
}

int BattlePlan::noObjectives() {
	return noObjs;
}

Objective BattlePlan::getMatchingObjective(int resources, sint4 executer) {

	Objective best;
	best.cmd = NONE_FOUND;
	
	//Find matching objective
	Objective match;
	match.cmd = NONE_FOUND;
	vector<Objective>::iterator it = objectives.begin();
	while (it != objectives.end()) {
		if (it->executer == executer) {
			match = *it;
			break;
		}
		it++;
	}

	if (match.cmd != NONE_FOUND) {
		if (resources - match.minResources > 0) {
			/*best.cmd = match.cmd;
			best.no = match.no;
			best.executer = match.executer;*/
			best = match;
		}
	}
	
	return best;
}

void BattlePlan::objectiveExecuted(sint4 executer) {
	//Find matching objective
	vector<Objective>::iterator it = objectives.begin();
	while (it != objectives.end()) {
		if (it->executer == executer) {
			it->done++;
			if (it->done >= it->no) {
				objectives.erase(it);
				noObjs--;
			}
			return;
		}
		it++;
	}
}


