#include "Blackboard.H"
#include "TotalPF.H"
#include "TBConfig.H"
#include "UnitAgent.H"

using namespace std;

const sint4 Blackboard::TYPE_TANK = 0;
const sint4 Blackboard::TYPE_MARINE = 1;
const sint4 Blackboard::TYPE_BASE = 2;
const sint4 Blackboard::TYPE_WORKER = 3;
const sint4 Blackboard::TYPE_BARRACKS = 4;
const sint4 Blackboard::TYPE_FACTORY = 5;
const sint4 Blackboard::TYPE_MAIN = 6;

const sint4 Blackboard::DEFEND = 10;
const sint4 Blackboard::ATTACK = 11;

sint4 Blackboard::state = 10;

bool Blackboard::BARRACKS_BUILT = false;
bool Blackboard::FACTORY_BUILT = false;
bool Blackboard::CONTROLCENTER_BUILT = false;

int Blackboard::map_w = 0;
int Blackboard::map_h = 0;
int Blackboard::game_type = 0;

/*
	Gets the type (tank, marine or base) for a unit.
*/
int Blackboard::getType(GameObjPtr unit) {
	std::string objType = unit->bp_name();

	if (objType == "tank") {
		return Blackboard::TYPE_TANK;
	}
	else if (objType == "marine") {
		return Blackboard::TYPE_MARINE;
	}
	else if (objType == "controlCenter") {
		return Blackboard::TYPE_BASE;
	}
	else if (objType == "worker") {
		return Blackboard::TYPE_WORKER;
	}
	else if (objType == "barracks") {
		return Blackboard::TYPE_BARRACKS;
	}
	else if (objType == "factory") {
		return Blackboard::TYPE_FACTORY;
	}
	else {
		cout << "Unknown unit type:" << objType << endl;
		return Blackboard::TYPE_BASE;
	}
}

void Blackboard::dumpTypeStr(int type) {
	if (type == (int)TYPE_TANK) {
		cout << "tank";
	}
	else if (type == (int)TYPE_MARINE) {
		cout << "marine";
	}
	else if (type == (int)TYPE_WORKER) {
		cout << "worker";
	}
	else if (type == (int)TYPE_BASE) {
		cout << "controlCenter";
	}
	else if (type == (int)TYPE_BARRACKS) {
		cout << "barracks";
	}
	else if (type == (int)TYPE_FACTORY) {
		cout << "factory";
	}
	else {
		cout << "unk";
	}
}
