#ifndef Blackboard_H
#define Blackboard_H

#include "GameObj.H"
#include "Game.H"
#include "TBConfig.H"

using namespace std;

/*
	This class holds a global Blackboard with constants, useful methods and variables
	for coordination.
*/
class Blackboard {
	
	typedef GameObj* GameObjPtr;

	public:

		/*
			Gets the type (for example tank, base, worker) for a unit.
		*/
		static int getType(GameObjPtr unit);

		//Blackboard item for bases
		static const sint4 TYPE_BASE;
		//Blackboard item for barracks
		static const sint4 TYPE_BARRACKS;
		//Blackboard item for factory
		static const sint4 TYPE_FACTORY;
		//Blackboard item for tanks
		static const sint4 TYPE_TANK;
		//Blackboard item for marines
		static const sint4 TYPE_MARINE;
		//Blackboard item for workers
		static const sint4 TYPE_WORKER;
		//Used for main actions in the battleplan
		static const sint4 TYPE_MAIN;
		
		//Current state if the game. See constants below
		static sint4 state;

		//Stay back and defend own bases
		static const sint4 DEFEND;
		//Move to attack opponent units and bases
		static const sint4 ATTACK;

		//Sets to true when barracks has been built
		static bool BARRACKS_BUILT;
		//Sets to true when a factory has been built
		static bool FACTORY_BUILT;
		//Sets to true when a base/controlCenter has been built
		static bool CONTROLCENTER_BUILT;

		static void dumpTypeStr(int type);

		static int map_w;
		static int map_h;

		static int game_type;
};

#endif
