#ifndef Trail_H
#define Trail_H

#include "GameObj.H"

using namespace std;

/*
	Struct for each position in a trail.
*/
struct TrailElement {
	int x;
	int y;
	uint4 game_tick;

	bool equals(int mX, int mY) {
		if (mX == x && mY == y) {
			return true;
		}
		return false;
	}

	real8 getP(uint4 c_game_tick) {
		/*real8 mul = 0;
		real8 diff = (real8)c_game_tick - (real8)game_tick;
		if (diff <= 50) {
			mul = (real8)1;
		}
		else if (diff <= 80) {
			mul = (real8)1 - (diff - (real8)50) / (real8)30;
		}

		return -6 * mul; //-6 * mul   -12*/
		return -6;
	}
};

/*
	This class handles the "pheromone" trail used to avoid local maxima. 
*/
class Trail {
	
	public:

		/*
			Updates the position of this unit.
		*/
		void update(int x, int y, uint4 game_tick);

		/*
			Inits the trail for this unit.
		*/
		void init( int x, int y, uint4 game_tick);

		/*
			Returns the trail potential in a point at a given time.
		*/
		real8 getP(int x, int y, uint4 game_tick);

	private:
		
		static uint4 length;
		vector<TrailElement> trail;
};

#endif
